#!/usr/bin/perl

use strict;
package QBlocker;

my @erlaubt;

###################################################################
# Hier bitte die Notwendigen Einstellungen vornehmen
# Modify these text messages for your needs.
###################################################################

# Diese Nachricht wird dem User angezeigt, der dich anqueryt.
#This message is sent to the user which is blocked
my $deny_message = "Automatische Ignoranz: Du wirst ab jetzt fr 60 Sekunden ignoriert.";
# Diese Nachricht wird dem User angezeigt, wenn du ihm den erfragten Query erlaubst.
# This message is sent to a user which is allowed immediately to query you.
my $allow_message = "Automatische Antwort: Query akzeptiert";

###################################################################
# Ab hier bitte nur ndern, wenn du weisst, was du tust!
###################################################################
my $scriptname = "GodOfGTA's Query Blocker modif by Zap-Zarerap - made usable by gargelkarg+checkit - improved by DocTrax";
my $version = "1.31a";
my $home = IRC::get_info(4);
my $confpath = "$home/queryblocker.conf";

IRC::register ($scriptname, $version, "", "");
IRC::add_command_handler("qb", "QBlocker::qb_on_off");
IRC::add_command_handler("oki", "QBlocker::erlauben");
IRC::add_command_handler("weg", "QBlocker::nichterlauben");
IRC::add_command_handler("wer", "QBlocker::allowliste");
IRC::add_command_handler("qbhelp", "QBlocker::hilfesystem");
IRC::add_command_handler("qbhelpen", "QBlocker::hilfesystemen");
IRC::add_command_handler("query", "QBlocker::eigenerquery");
IRC::add_message_handler("PRIVMSG" , "QBlocker::auto_answer");
IRC::print(chr(3) . "5,8Query-Blocker Script geladen und aktiviert! The Queryblocker is loaded and activated!\n" . chr(3));
IRC::print(chr(3) . "4,8Zum deaktivieren /qb Hilfesystem mit /qbhelp" . chr(3));
IRC::print(chr(3) . "4,8To deactiveate it /qb For English help type /qbhelpen" . chr(3));
my $qbs = 1;
my $letzternick = " ";
&QBlocker::load_conf();

my $MyName = (IRC::get_info(1));

if (&QBlocker::check_in_list($MyName) == -1) 
{
	push(@erlaubt,$MyName);
}


sub check_in_list 
{
	my $nick = join (" ", @_ );
	my $cnt = 0;
	foreach  (@erlaubt) 
	{
		if (uc($_) eq uc($nick)) 
		{
			return $cnt;
		}
		$cnt++;
	}
	return -1;
}


sub eigenerquery 
{
	my $line = join ( " " , @_);
	if($qbs==1) 
	{
		if (&QBlocker::check_in_list($line) == -1) 
		{
			push(@erlaubt,$line);
		}
		&QBlocker::save_conf();
	}
	return 0;
}

sub erlauben 
{
	my $nick = join (" ", @_);
	if ($qbs==1) 
	{
		if ($nick ne "") 
		{
			if (&QBlocker::check_in_list($nick) == -1) 
			{
				push(@erlaubt,$nick);
			}
			else 
			{
				IRC::print($nick." ist schon in der allow-liste.");
			}
		}
		else 
		{
			if($letzternick eq " ") 
			{
				return 1;
			}
			push(@erlaubt,$letzternick);
			IRC::command("/query " . $letzternick);
			IRC::command("/msg " . $letzternick . $allow_message);
		}
		&QBlocker::save_conf();
	}
	return 1;
}

sub nichterlauben
{
	my $nick = join (" ", @_);
	my $idx;
	my $temp;

	if($qbs==1) 
	{
		if($nick ne "") 
		{
			$idx = &QBlocker::check_in_list($nick);
			if ($idx == -1) 
			{
				IRC::print("$nick ist nicht in der allow-liste.");
				return 1;
			}
			else 
			{
				$temp = splice(@erlaubt,$idx,1);
			}
		}
		else 
		{
			$temp = pop(@erlaubt);
		}
		IRC::print("Query's von $temp werden wieder geblockt");
		&QBlocker::save_conf();
	}
	return 1;
}

sub allowliste 
{
	my $schleife= 0;
	my $temp;
	
	IRC::print("Diesen Usern ist der Query erlaubt:\n");
	foreach $temp (@erlaubt) 
	{
		IRC::print("($schleife) $temp");
		$schleife++; 
	}
	return 1;
}

sub qb_on_off {
	if($qbs == 1) 
	{
		IRC::print("Der Query-Blocker wurde deaktiviert!\nZum reaktivieren einfach nochmal /qb");
		$qbs = 0;
		return 1; 
	}
	else  
	{
		IRC::print("Der Query-Blocker wurde aktiviert!\nZum deaktivieren einfach nochmal /qb");
		$qbs = 1;
		return 1; 
	}
}


sub auto_answer 
{
	if($qbs != 0) 
	{
		my $temp;
		my $line = join ( " ", @_);
		my $MyName = ( IRC::get_info(1) );
		if($line =~ m/:(.*)\!.* PRIVMSG $MyName :(.*)/) 
		{
			my $QUser = $1;
			$letzternick = $1;
			my $QMessage = $2;
			foreach $temp (@erlaubt) 
			{
				if($temp eq $QUser) 
				{
					return 0; 
				} 
			}
			IRC::print( chr(3) ."4,10" . $QUser . chr(3) . "1,10 will was im Query: " . chr(3) . "2,10::" . $QMessage . chr(3) . "2,10 ::" );
			IRC::command("/msg $QUser $deny_message ");
			return 1; 
		}
		else 
		{
			return 0; 
		} 
	}
	else 
	{
		return 0; 
	}
}

sub hilfesystem 
{
	IRC::print( chr(3) . "2,8".$scriptname."---------------------------------------- v".$version . chr(3) );
	IRC::print( chr(3) . "5,8Befehle: " . chr(3) );
	IRC::print( chr(3) . "5,8/qb    -> Schaltet die Funktionen des Query-Blockers ein oder aus." . chr(3) );
	IRC::print( chr(3) . "5,8/oki         -> Dem letzten User, die versucht hat, Dich per Query zu erreichen, diesen erlauben (Query akzeptiert)." . chr(3) );
	IRC::print( chr(3) . "5,8/oki nick    -> Dem User mit nick erlauben zu dir Queries aufzubauen" . chr(3) );
	IRC::print( chr(3) . "5,8/wer         -> Zeigt die Liste der User auf, denen Du den Query erlaubst." . chr(3) );
	IRC::print( chr(3) . "5,8/weg         -> Dem letzten User, dem Du den Query erlaubt hast, dieses Recht wieder nehmen." . chr(3) );
	IRC::print( chr(3) . "5,8/weg nick    -> Dem User nick, dem Du den Query erlaubt hast, dieses Recht wieder nehmen." . chr(3) );
	IRC::print( chr(3) . "5,8/qbhelp      -> Dieses Hilfesystem :)" . chr(3) );
	return 1;
}

sub hilfesystemen
{
	IRC::print( chr(3) . "2,8".$scriptname."---------------------------------------- v".$version. chr(3) );
	IRC::print( chr(3) . "5,8Commands: ". chr(3) );
	IRC::print( chr(3) . "5,8/qb          -> Activates or deactivates the Queryblocker". chr(3) );
	IRC::print( chr(3) . "5,8/oki         -> Allows a query for the last user trying to query you." . chr(3) );
	IRC::print( chr(3) . "5,8/oki nick    -> Allows a query for user nick." . chr(3) );
	IRC::print( chr(3) . "5,8/wer         -> Shows the list of users which are allowed to query you" . chr(3) );
	IRC::print( chr(3) . "5,8/weg         -> Blocks the last user (in list) again." . chr(3) );
	IRC::print( chr(3) . "5,8/weg nick    -> Blocks the user nick again." . chr(3) );
	IRC::print( chr(3) . "5,8/qbhelpen      -> This help message :)" . chr(3) );
	return 1;
}

sub load_conf 
{
	open (CONF, "<$confpath");
	if ( -f CONF) 
	{
		while (<CONF>) 
		{
			chop;
			push (@erlaubt, $_);
		}
		close CONF;
		IRC::print( chr(3) . "7,8Config file ".$confpath." loaded" . chr(3));
	}
	else
	{
		IRC::print( chr(3) . "7,8Fatal: Config file ".$confpath." not found!" . chr(3));
	}
}


sub save_conf 
{
	open (CONF, ">$confpath");
	if ( -f CONF) 
	{
		foreach (@erlaubt) 
		{
			print CONF $_."\n";
		}
		close CONF;
	}
}
